﻿local _CommonFunctions, StoneGateSetPrefix, CommonWindowPrefix, StoneGateSetPrefixWhiteFloor, CommonDoorPrefix, _CommonFlagPrefix, _HomePrefix = ...

_CommonFunctions:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")
_CommonFunctions:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")
_optionAccessNodeType = "STONEGATEACCESS"
_CommonFunctions:registerEnumValue ("ATTACH_NODE_TYPE", _optionAccessNodeType)
_optionPinionNodeType = "STONEGATEPINION"
_CommonFunctions:registerEnumValue ("ATTACH_NODE_TYPE", _optionPinionNodeType)

-- register specific housing function
function registerFunctionHouse(_assetPrefix, _assetId, _lvl)
        function houseStatusList()
            function houseStatus(_desirabilityLevel)
                return {
	            DataType = "HOUSE_STATUS",
	            RequiredDesirability = _desirabilityLevel,
	            ResourceGenerated = "HOUSING_LEVEL_" .. _lvl,
	            HouseDensityPartList = { _assetPrefix .. "_" .. _assetId .. "_PART" }
                }
            end
            if _lvl == "1" then
                return {
	            houseStatus(DESIRABILITY_LEVEL.LOW),
	            houseStatus(DESIRABILITY_LEVEL.HIGH)
	        }
            end
            if _lvl == "2" then
	        return {
	            houseStatus(DESIRABILITY_LEVEL.AVERAGE),
	            houseStatus(DESIRABILITY_LEVEL.VERY_HIGH)
	        }
            end
            return nil
        end

        _CommonFunctions:registerAsset({
	    DataType= "HOUSE_SETUP",
	    Id = _assetPrefix .. "_" .. _assetId .. "_HOUSING_LVL" .. _lvl .. "_SETUP",
	    HouseStatusList = houseStatusList()
        })
        _CommonFunctions:registerAsset({
	    DataType = "BUILDING_FUNCTION_HOUSE",
	    Id = _assetPrefix .. "_" .. _assetId .. "_HOUSING_LVL" .. _lvl .. "_FUNCTION",
            Name = _assetPrefix .. "_BUILDING_FUNCTION_HOUSING_LVL" .. _lvl .. "_NAME",
	    RelatedZone = "RESIDENTIAL",
	    RelatedDesirability = "DESIRABILITY_RESIDENTIAL",
	    AssetHouseSetup =  _assetPrefix .. "_" .. _assetId .. "_HOUSING_LVL" .. _lvl .. "_SETUP",
        })
        return _assetPrefix .. "_" .. _assetId .. "_HOUSING_LVL" .. _lvl .. "_FUNCTION"
end

-- Register the stone gate set material list

function configureMaterialSet(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _colorFlag, _defaultMaterial, _custom)
    if _custom then
        return  {
                SetName = StoneGateSetPrefix .. "_CUSTOM_THEME",
                MaterialList =  configureMaterialList(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _colorFlag, _defaultMaterial)
        }
    end
    
    return  {
                SetName = StoneGateSetPrefix .. "_" .. _colorRoof ..  "_" .. _colorWall,
                MaterialList =  configureMaterialList(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _colorFlag, _defaultMaterial)
   }
end

function configureMaterialList(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _colorFlag, _defaultMaterial)
    function configureWindowRoofMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorRoof .. "_ROOF_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorRoof .. "_ROOF_MATERIAL"
        end
    end
    function configureWindowFlagMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorFlag .. "_FLAG_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFlag .. "_FLAG_MATERIAL"
        end
    end
    function configureWindowWallMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureWindowFrameMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorFrame .. "_FRAME_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFrame .. "_FRAME_MATERIAL"
        end
    end
    function configureSimpleRoofMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorRoof .. "_ROOF_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorRoof .. "_ROOF_MATERIAL"
        end
    end
    function configureRoofOverMachicolationsMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_" .. _colorRoof .. "_ROOF_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorRoof .. "_ROOF_MATERIAL"
        end
    end
    function configureWallMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureFrameMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorFrame .. "_FRAME_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFrame .. "_FRAME_MATERIAL"
        end
    end
    function configureCrenellationMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        end
    end
    function configureBasementMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        end
    end
    function configureFloorGroundMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        end
    end
    
    return {
                    -- from Windows Decoration mod
                    configureWindowRoofMaterial("STONE_WINDOW"),
-- currently not used                    configureWindowRoofMaterial("WOODEN_DOOR"),
                    configureWindowRoofMaterial("WOODEN_WINDOW"),
                    configureWindowRoofMaterial("WOODEN_ENTRANCE"),
                    configureWindowWallMaterial("STONE_DECORATION"),
                    configureWindowWallMaterial("STONE_BUTTRESS"),
                    configureWindowFrameMaterial("STONE_DECORATION"),
                    configureWindowFrameMaterial("STONE_DECORATION3"),
                    configureWindowFrameMaterial("STONE_DOORS"),
                    configureWindowFrameMaterial("CORNER"),
                    configureWindowFrameMaterial("STAINED_GLASS"),
                    configureWindowFlagMaterial("FLAPING"),
                    -- simple roofs
                    configureSimpleRoofMaterial("MAIN"),
                    configureSimpleRoofMaterial("KEEP"),
                    configureSimpleRoofMaterial("SST"),
                    configureSimpleRoofMaterial("SGATE"),
                    configureSimpleRoofMaterial("A45"),
                    configureSimpleRoofMaterial("OTOWER"),
                    configureSimpleRoofMaterial("CIRCULAR"),
                    configureSimpleRoofMaterial("SCT"),
                    -- domes
                    configureSimpleRoofMaterial("MAIN_DOME"),
                    configureSimpleRoofMaterial("KEEP_DOME"),
                    configureSimpleRoofMaterial("OTOWER_DOME"),
                    configureSimpleRoofMaterial("CIRCULAR_DOME"),
                    configureSimpleRoofMaterial("SCT_DOME"),
                    -- pointed roofs
                    configureSimpleRoofMaterial("POINTED_MAIN"),
                    configureSimpleRoofMaterial("POINTED_KEEP"),
                    configureSimpleRoofMaterial("POINTED_SST"),
                    configureSimpleRoofMaterial("POINTED_OTOWER"),
                    configureSimpleRoofMaterial("POINTED_CIRCULAR"),
                    configureSimpleRoofMaterial("POINTED_SCT"),
                    configureSimpleRoofMaterial("POINTED_SGATE"),
                    configureSimpleRoofMaterial("POINTED_A45"),
                    -- roofs over machicolations
                    configureRoofOverMachicolationsMaterial("MAIN"),
                    configureRoofOverMachicolationsMaterial("KEEP"),
                    configureRoofOverMachicolationsMaterial("SST"),
                    configureRoofOverMachicolationsMaterial("SGATE"),
                    configureRoofOverMachicolationsMaterial("SGATE2"),
                    configureRoofOverMachicolationsMaterial("A45"),
                    configureRoofOverMachicolationsMaterial("OTOWER"),
                    configureRoofOverMachicolationsMaterial("CIRCULAR"),
                    configureRoofOverMachicolationsMaterial("SCT"),
                    -- wall
                    configureWallMaterial("OVER_HANGING"),
                    configureWallMaterial("A45"),
                    configureWallMaterial("CIRCULAR"),
                    configureWallMaterial("KEEP"),
                    configureWallMaterial("LARGE_GATE"),
                    configureWallMaterial("MAIN"),
                    configureWallMaterial("OTOWER"),
                    configureWallMaterial("SCT"),
                    configureWallMaterial("SGATE"),
                    configureWallMaterial("SST"),
                    configureWallMaterial("OTHER"),
                    configureWallMaterial("DECORATIONS_PINION"),
                    configureWallMaterial("DRAWBRIDGE_A"),
                    configureWallMaterial("MACHICOLATION_KEEP"),
                    configureWallMaterial("MACHICOLATION_MAIN"),
                    configureWallMaterial("MACHICOLATION_SST"),
                    configureWallMaterial("MACHICOLATION_SGATE"),
                    configureWallMaterial("MACHICOLATION_A45"),
                    configureWallMaterial("MACHICOLATION_OTOWER"),
                    configureWallMaterial("MACHICOLATION_CIRCULAR"),
                    configureWallMaterial("MACHICOLATION_SCT"),
                    configureWallMaterial("POINTED_ROOFS_PINION"),
                    -- crenellation
                    configureCrenellationMaterial("RAMPART_A45"),
                    configureCrenellationMaterial("RAMPART_CIRCULAR"),
                    configureCrenellationMaterial("RAMPART_KEEP"),
                    configureCrenellationMaterial("RAMPART_MAIN"),
                    configureCrenellationMaterial("RAMPART_OTOWER"),
                    configureCrenellationMaterial("RAMPART_SCT"),
                    configureCrenellationMaterial("SGATE"),
                    configureCrenellationMaterial("RAMPART_SST"),
                    configureCrenellationMaterial("OTHER"),
                    configureCrenellationMaterial("HOARDING_A45"),
                    configureCrenellationMaterial("HOARDING_CIRCULAR"),
                    configureCrenellationMaterial("HOARDING_OTOWER"),
                    configureCrenellationMaterial("HOARDING_S3"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S3"),
                    configureCrenellationMaterial("HOARDING_S2"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S2"),
                    configureCrenellationMaterial("HOARDING_S1"),
                    configureCrenellationMaterial("HOARDING_SGATE"),
                    configureCrenellationMaterial("HOARDING_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_KEEP"),
                    configureCrenellationMaterial("MACHICOLATION_CRENATION"),
                    configureCrenellationMaterial("MACHICOLATION_MAIN"),
                    configureCrenellationMaterial("MACHICOLATION_SST"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_A45"),
                    configureCrenellationMaterial("MACHICOLATION_OTOWER"),
                    configureCrenellationMaterial("MACHICOLATION_CIRCULAR"),
                    configureCrenellationMaterial("MACHICOLATION_SCT"),
                    -- basement
                    configureBasementMaterial("MAIN"),
                    configureBasementMaterial("KEEP"),
                    configureBasementMaterial("OTOWER"),
                    configureBasementMaterial("CIRCULAR"),
                    configureBasementMaterial("SST"),
                    -- floor ground
                    configureFloorGroundMaterial("SST"),
                    configureFloorGroundMaterial("OTHER"),
                    configureFloorGroundMaterial("MACHICOLATION_SST"),
                    configureFloorGroundMaterial("KEEP"),
                    configureFloorGroundMaterial("MACHICOLATION_KEEP"),
                    configureFloorGroundMaterial("MAIN"),
                    configureFloorGroundMaterial("MACHICOLATION_MAIN"),
                    configureFloorGroundMaterial("A45"),
                    configureFloorGroundMaterial("MACHICOLATION_A45"),
                    configureFloorGroundMaterial("CIRCULAR"),
                    configureFloorGroundMaterial("MACHICOLATION_CIRCULAR"),
                    configureFloorGroundMaterial("OTOWER"),
                    configureFloorGroundMaterial("MACHICOLATION_OTOWER"),
                    configureFloorGroundMaterial("SCT"),
                    configureFloorGroundMaterial("MACHICOLATION_SCT"),
                    configureFloorGroundMaterial("SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE2"),
                    configureFloorGroundMaterial("LARGE_GATE"),
                    -- frame
                    configureFrameMaterial("LARGE_GATE"),
                    configureFrameMaterial("SCT"),
                    configureFrameMaterial("SGATE"),
                    configureFrameMaterial("SST"),
                    configureFrameMaterial("DECORATIONS_DECORATION"),
                    configureFrameMaterial("DRAWBRIDGE_A"),
                    configureFrameMaterial("DRAWBRIDGE_B"),
                    configureFrameMaterial("DRAWBRIDGE_C"),
                    configureFrameMaterial("MACHICOLATION_KEEP"),
                    configureFrameMaterial("MACHICOLATION_MAIN"),
                    configureFrameMaterial("MACHICOLATION_SST"),
                    configureFrameMaterial("MACHICOLATION_SGATE"),
                    configureFrameMaterial("MACHICOLATION_SGATE2"),
                    configureFrameMaterial("MACHICOLATION_A45"),
                    configureFrameMaterial("MACHICOLATION_OTOWER"),
                    configureFrameMaterial("MACHICOLATION_CIRCULAR"),
                    configureFrameMaterial("MACHICOLATION_SCT"),
               
    }
end

function configureMaterialSetList(_configureMaterialSet)
    return {
            _configureMaterialSet("RED_TILE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "RED", true, false), -- default material
            _configureMaterialSet("BLUE_TILE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "BLUE", false, false),
            _configureMaterialSet("BROWN_TILE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "GREEN", false, false),
            _configureMaterialSet("LIGHT_GREY_TILE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "ORANGE", false, false),
            _configureMaterialSet("DARK_GREY_TILE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "PURPLE", false, false),
            _configureMaterialSet("RED_SHINGLE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "TURQUOISE", false, false),
            _configureMaterialSet("BLUE_SHINGLE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "RED", false, false),
            _configureMaterialSet("BROWN_SHINGLE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "BLUE", false, false),
            _configureMaterialSet("YELLOW_SHINGLE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "GREEN", false, false),
            _configureMaterialSet("GREEN_SHINGLE", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "ORANGE", false, false ),
            _configureMaterialSet("WOODEN_MANOR", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "PURPLE", false, false),
            _configureMaterialSet("STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "TURQUOISE", false, false),
            _configureMaterialSet("BROWN_MONASTERY", "BROWN_MONASTERY", "BROWN_MONASTERY", "BROWN_MONASTERY", "WHITE_STONE", "WHITE_STONE", "RED", false, false),
            _configureMaterialSet("BLUE_MONASTERY", "BLUE_MONASTERY", "BLUE_MONASTERY", "BLUE_MONASTERY", "WHITE_STONE", "WHITE_STONE", "BLUE", false, false),
            _configureMaterialSet("PURPLE_MONASTERY", "PURPLE_MONASTERY", "PURPLE_MONASTERY", "PURPLE_MONASTERY", "WHITE_STONE", "WHITE_STONE", "GREEN", false, false),
            _configureMaterialSet("WOODEN_MANOR", "RED_STONE", "RED_STONE", "RED_STONE", "RED_STONE", "WHITE_STONE", "ORANGE", false, false),
            _configureMaterialSet("RED_SHINGLE", "GIANT_GATE", "GIANT_GATE", "GIANT_GATE", "WHITE_STONE", "WHITE_STONE", "PURPLE", false, false),
            _configureMaterialSet("STRAW", "WHITE_CHALK", "WHITE_CHALK", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "TURQUOISE", false, false),
            _configureMaterialSet("BROWN_MONASTERY", "WHITE_CHALK", "WHITE_CHALK", "STONE_MANOR", "WHITE_STONE", "WHITE_STONE", "RED", false, false),
            _configureMaterialSet("RED_TILE", "SAND_STONE", "SAND_STONE", "SAND_STONE", "WHITE_STONE", "WHITE_STONE", "BLUE", false, false),
            _configureMaterialSet("BROWN_TILE", "SAND_STONE", "SAND_STONE", "SAND_STONE", "WHITE_STONE", "WHITE_STONE", "GREEN", false, false),
            _configureMaterialSet("STRAW", "WOOD", "WHITE_CHALK", "STONE_MANOR", "WHITE_STONE", "WOOD", "ORANGE", false, false),
            _configureMaterialSet("DARK_GREY_TILE", "AMERICAN_SHINGLE", "WHITE_CHALK", "STONE_MANOR", "WHITE_STONE", "WHITE_CHALK", "TURQUOISE", false, false),
            _configureMaterialSet(_CustomRoofMaterial,
                                  _CustomWallMaterial,
                                  _CustomCrenellationMaterial,
                                  _CustomBasementMaterial,
                                  _CustomGroundMaterial,
                                  _CustomFrameMaterial,
                                  _CustomFlagMaterial,
                                  false, true),
    }
end

function configureBuildingPartSetList()
    return {
		{
			Name = _HomePrefix .. "_PARTSETLIST_NAME",
	                BuildingPartList = {
		            _HomePrefix .. "_ALL_MAIN_PART",
		            _HomePrefix .. "_ALL_KEEP_PART",
		            _HomePrefix .. "_ALL_SST_PART",
		            _HomePrefix .. "_ALL_OTOWER_PART",
		            _HomePrefix .. "_ALL_CIRCULAR_PART",
		            _HomePrefix .. "_ALL_SCT_PART",
		            _HomePrefix .. "_HOUSE_MAIN_PART",
		            _HomePrefix .. "_HOUSE_KEEP_PART",
		            _HomePrefix .. "_HOUSE_SST_PART",
		            _HomePrefix .. "_HOUSE_OTOWER_PART",
		            _HomePrefix .. "_HOUSE_CIRCULAR_PART",
		            _HomePrefix .. "_HOUSE_SCT_PART",
		            _HomePrefix .. "_RAMPART_MAIN_PART",
		            _HomePrefix .. "_RAMPART_KEEP_PART",
		            _HomePrefix .. "_RAMPART_SST_PART",
		            _HomePrefix .. "_RAMPART_OTOWER_PART",
		            _HomePrefix .. "_RAMPART_CIRCULAR_PART",
		            _HomePrefix .. "_RAMPART_SCT_PART",
                         }
                },

		{
			Name = StoneGateSetPrefix .. "_MAIN_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_MAIN_ROOT_PART",
		            StoneGateSetPrefix .. "_MAIN_ROOTP_PART",
		            StoneGateSetPrefix .. "_MAIN_ROOTHALFWHITE_PART",
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED45_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE45_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_3SHED45_PART",     -- shed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED30_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE30_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_3SHED30_PART",     -- shed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_3SHED24_PART",     -- shed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED60_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE60_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_3SHED60_PART",     -- shed roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_2OPPOSITE_PART",
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_1OPENED_PART",
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_4CLOSED_PART",
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_1OPENED_PART",   -- half opened roof 1
		            StoneGateSetPrefix .. "_MAIN_RAMPART_4CLOSED_PART",   -- Closed rampart
		            StoneGateSetPrefix .. "_MAIN_RAMPART_2OPPOSITE_PART", -- Opened rampart
		            StoneGateSetPrefix .. "_MAIN_RAMPART_1OPENED_PART",   -- half opened rampart 1
		            StoneGateSetPrefix .. "_WFMAIN_A_PART",
		            StoneGateSetPrefix .. "_WFMAIN_B_PART",
		            StoneGateSetPrefix .. "_WFMAIN_C_PART",
		            StoneGateSetPrefix .. "_WFMAIN_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFMAIN_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFMAIN_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFMAIN_C_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_KEEP_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOT_PART",
		            StoneGateSetPrefix .. "_KEEP_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEP_ROOTHALFWHITE_PART",
		            StoneGateSetPrefix .. "_KEEPH_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEPI_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEPJ_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEPK_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEPL_ROOTP_PART",
		            StoneGateSetPrefix .. "_LGATE_ROOT_PART",
		            StoneGateSetPrefix .. "_LGATE_ROOTP_PART",
		            StoneGateSetPrefix .. "_LGATE_2_ROOT_PART",
		            StoneGateSetPrefix .. "_LGATE_2_ROOTP_PART",
		            StoneGateSetPrefix .. "_LGATE_3_ROOT_PART",
		            StoneGateSetPrefix .. "_LGATE_3_ROOTP_PART",
		            StoneGateSetPrefix .. "_LGATE_4_ROOT_PART",
		            StoneGateSetPrefix .. "_LGATE_4_ROOTP_PART",
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED45_PART",            -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED45_PART",            -- 1 side opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE45_PART",          -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT45_PART",          -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED45_PART",            -- 3 sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED45_PART",            -- all sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_ADVANCED45_PART", -- roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_STRAIGHT45_PART", -- roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_STONE45_PART",
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_CREAM45_PART", -- simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_STONE45_PART", -- simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WOOD45_PART", -- simple full wodden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WHITE45_PART", -- simple pinion
		            StoneGateSetPrefix .. "_KEEP_ROOF_3SHED45_PART",                         -- shed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2SHED45_PART",                         -- shed roof with 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_RIGHT45_PART", -- shed roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_LEFT45_PART",  -- shed roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_STONE45_PART", -- left shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_STONE45_PART", -- right shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_CREAM45_PART", -- left shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_CREAM45_PART", -- right shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WOOD45_PART", -- left shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WOOD45_PART", -- right shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WHITE45_PART", -- left pinion for shed roof
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WHITE45_PART", -- right pinion for shed roof
		            StoneGateSetPrefix .. "_KEEP_RAMPART_4CLOSED_PART", -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_RAMPART_1OPENED_PART", -- 1 side opened
		            StoneGateSetPrefix .. "_KEEP_RAMPART_2OPPOSITE_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_KEEP_RAMPART_2ADJACENT_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_RAMPART_3OPENED_PART", -- 3 sides opened
		            StoneGateSetPrefix .. "_KEEP_RAMPART_4OPENED_PART", -- all sides opened
		            StoneGateSetPrefix .. "_WFKEEP_A_PART",
		            StoneGateSetPrefix .. "_WFKEEP_B_PART",
		            StoneGateSetPrefix .. "_WFKEEP_C_PART",
		            StoneGateSetPrefix .. "_WFKEEP_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFKEEP_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFKEEP_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFKEEP_C_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_KEEP_POINTED_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_3OPENED_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2OPPOSITE_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_1OPENED_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2ADJACENT_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4OPENED_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4CLOSED_PART",
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_EXTENSION_ADVANCED_PART", -- roof extension
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_EXTENSION_STRAIGHT_PART", -- roof extension
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_C_PART", -- pointed pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_G_PART", -- pointed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_I_PART", -- pointed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_D_PART", -- pointed pinion
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_KEEP30_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED30_PART",            -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED30_PART",            -- 1 side opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE30_PART",          -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT30_PART",          -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED30_PART",            -- 3 sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED30_PART",            -- all sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_ADVANCED30_PART", -- roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_STRAIGHT30_PART", -- roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_CREAM30_PART", -- simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_STONE30_PART", -- simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WOOD30_PART", -- simple full wodden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WHITE30_PART", -- simple pinion
		            StoneGateSetPrefix .. "_KEEP_ROOF_3SHED30_PART",                         -- shed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2SHED30_PART",                         -- shed roof with 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_RIGHT30_PART", -- shed roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_LEFT30_PART",  -- shed roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_STONE30_PART", -- left shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_STONE30_PART", -- right shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_CREAM30_PART", -- left shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_CREAM30_PART", -- right shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WOOD30_PART", -- left shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WOOD30_PART", -- right shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WHITE30_PART", -- left pinion for shed roof
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WHITE30_PART", -- right pinion for shed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_3SHED24_PART",                         -- shed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2SHED24_PART",                         -- shed roof with 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_RIGHT24_PART", -- shed roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_LEFT24_PART",  -- shed roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_STONE24_PART", -- left shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_STONE24_PART", -- right shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_CREAM24_PART", -- left shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_CREAM24_PART", -- right shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WOOD24_PART", -- left shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WOOD24_PART", -- right shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WHITE24_PART", -- left pinion for shed roof
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WHITE24_PART", -- right pinion for shed roof
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_KEEP60_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED60_PART",            -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED60_PART",            -- 1 side opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE60_PART",          -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT60_PART",          -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED60_PART",            -- 3 sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED60_PART",            -- all sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_ADVANCED60_PART", -- roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_EXTENSION_STRAIGHT60_PART", -- roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_CREAM60_PART", -- simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_STONE60_PART", -- simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WOOD60_PART", -- simple full wodden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_SIMPLE_WHITE60_PART", -- simple pinion
		            StoneGateSetPrefix .. "_KEEP_ROOF_3SHED60_PART",                         -- shed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2SHED60_PART",                         -- shed roof with 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_RIGHT60_PART", -- shed roof extension
		            StoneGateSetPrefix .. "_KEEP_ROOF_SHED_EXTENSION_STRAIGHT_LEFT60_PART",  -- shed roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_STONE60_PART", -- left shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_STONE60_PART", -- right shed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_CREAM60_PART", -- left shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_CREAM60_PART", -- right shed cream pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WOOD60_PART", -- left shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WOOD60_PART", -- right shed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION2_LEFT_SHED_WHITE60_PART", -- left pinion for shed roof
		            StoneGateSetPrefix .. "_DECORATION_PINION2_RIGHT_SHED_WHITE60_PART", -- right pinion for shed roof
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_KEEPDOME_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2OPPOSITE_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_1OPENED_PART",   -- 1 side opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2ADJACENT_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_3OPENED_PART",   -- 3 sides opened
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4OPENED_PART",   -- all sides opened
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_HOARDING_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_HOARDING_S2L0R0_PART",
		            StoneGateSetPrefix .. "_HOARDING_S2L0R1_PART",
		            StoneGateSetPrefix .. "_HOARDING_S2L1R0_PART",
		            StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
		            StoneGateSetPrefix .. "_EXTENSION_S2L0R0_PART",
		            StoneGateSetPrefix .. "_HOARDING_S3L0R0_PART",
		            StoneGateSetPrefix .. "_HOARDING_S3L0R1_PART",
		            StoneGateSetPrefix .. "_HOARDING_S3L1R0_PART",
		            StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
		            StoneGateSetPrefix .. "_EXTENSION_S3L0R0_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_MACHICOLATION_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_MACHICOLATION_KEEP_PLATFORM_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_KEEP_PLATFORMP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION34_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION40R_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION40L_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_KEEP_ROOF_PLATFORM_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_MAIN_PLATFORM_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_MAIN_PLATFORMP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION54_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION60R_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION60L_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CRENATION70_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_MAIN_ROOF_PLATFORM_PART"
		        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SST_ROOT_PART",
		            StoneGateSetPrefix .. "_SST_ROOTP_PART",
		            StoneGateSetPrefix .. "_SST_ROOTGATE_PART",
		            StoneGateSetPrefix .. "_SST_ROOTGATEP_PART",
		            StoneGateSetPrefix .. "_SST_ROOTGATE2_PART",
		            StoneGateSetPrefix .. "_SST_ROOTGATE2P_PART",
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED45_PART", -- Closed roof
		            StoneGateSetPrefix .. "_SST_ROOF_1OPENED45_PART",  -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_ROOF_2OPPOSITE45_PART",  -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2ADJACENT45_PART",  -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_3OPENED45_PART",  -- 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_4OPENED45_PART",  -- all sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_STRAIGHT45_PART",  -- extension
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_ADVANCED45_PART",  -- extension
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_CREAM45_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_STONE45_PART", -- small simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WOOD45_PART", -- small simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WHITE45_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_SST_ROOF_3SHED45_PART",  -- shed roof wit 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2SHED45_PART",  -- shed roof wit 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_SHED_EXTENSION_STRAIGHT45_PART",  -- shed roof extension
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_CREAM45_PART", -- small shed simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_STONE45_PART", -- small shed simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WOOD45_PART", -- small shed simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WHITE45_PART", -- small shed simple pinion
		            StoneGateSetPrefix .. "_SST_RAMPART_4CLOSED_PART",  -- Close rampart
		            StoneGateSetPrefix .. "_SST_RAMPART_1OPENED_PART",   -- 1 side opened rampart
		            StoneGateSetPrefix .. "_SST_RAMPART_3OPENED_PART",   -- 1 side closed rampart
		            StoneGateSetPrefix .. "_HOARDING_S1_4CLOSED_PART",
		            StoneGateSetPrefix .. "_HOARDING_S1_1OPENED_PART",
		            StoneGateSetPrefix .. "_HOARDING_S1_3OPENED_PART",
		            StoneGateSetPrefix .. "_HOARDING_S1_2ADJACENT_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST_POINTED_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_2OPPOSITE_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_1OPENED_PART",   -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_2ADJACENT_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_EXTENSION_ADVANCED_PART", -- extension
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_EXTENSION_STRAIGHT_PART", -- extension
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_E_PART", -- small pointed pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_H_PART", -- small pointed stone pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_J_PART", -- small pointed full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_POINTED_PINION_F_PART", -- small pointed pinion
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST30_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED30_PART", -- Closed roof
		            StoneGateSetPrefix .. "_SST_ROOF_1OPENED30_PART",  -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_ROOF_2OPPOSITE30_PART",  -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2ADJACENT30_PART",  -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_3OPENED30_PART",  -- 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_4OPENED30_PART",  -- all sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_STRAIGHT30_PART",  -- extension
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_ADVANCED30_PART",  -- extension
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_CREAM30_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_STONE30_PART", -- small simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WOOD30_PART", -- small simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WHITE30_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_SST_ROOF_3SHED30_PART",  -- shed roof wit 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2SHED30_PART",  -- shed roof wit 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_SHED_EXTENSION_STRAIGHT30_PART",  -- shed roof extension
 		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_CREAM30_PART", -- small shed simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_STONE30_PART", -- small shed simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WOOD30_PART", -- small shed simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WHITE30_PART", -- small shed simple pinion
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST60_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED60_PART",    -- Closed roof
		            StoneGateSetPrefix .. "_SST_ROOF_1OPENED60_PART",    -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_ROOF_2OPPOSITE60_PART",  -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2ADJACENT60_PART",  -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_3OPENED60_PART",    -- 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_4OPENED60_PART",    -- all sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_STRAIGHT60_PART",  -- extension
		            StoneGateSetPrefix .. "_SST_ROOF_EXTENSION_ADVANCED60_PART",  -- extension
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_CREAM60_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_STONE60_PART", -- small simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WOOD60_PART", -- small simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SIMPLE_WHITE60_PART", -- small simple pinion
		            StoneGateSetPrefix .. "_SST_ROOF_3SHED60_PART",  -- shed roof wit 3 sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_2SHED60_PART",  -- shed roof wit 2 adjacent sides opened
		            StoneGateSetPrefix .. "_SST_ROOF_SHED_EXTENSION_STRAIGHT60_PART",  -- shed roof extension
 		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_CREAM60_PART", -- small shed simple pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_STONE60_PART", -- small shed simple stone pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WOOD60_PART", -- small shed simple full wooden pinion
		            StoneGateSetPrefix .. "_DECORATION_PINION1_SHED_WHITE60_PART", -- small shed simple pinion
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST_MACHICOLATION_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_4CLOSED_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_1OPENED_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_2OPPOSITE_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_2ADJACENT_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_3OPENED_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_4CLOSEDP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_1OPENEDP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_2OPPOSITEP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_2ADJACENTP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_RAMPART_3OPENEDP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_4CLOSED45_PART", -- Closed roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_1OPENED45_PART", -- 1 side opened roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2ADJACENT45_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2OPPOSITE45_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_4CLOSED30_PART", -- Closed roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_1OPENED30_PART", -- 1 side opened roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2ADJACENT30_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2OPPOSITE30_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_4CLOSED60_PART", -- Closed roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_1OPENED60_PART", -- 1 side opened roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2ADJACENT60_PART", -- 2 adjacent sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SST_ROOF_2OPPOSITE60_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_MACHICOLATION_2OPPOSITE_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_MACHICOLATION_1OPENED_PART",   -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_MACHICOLATION_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_MACHICOLATION_2ADJACENT_PART", -- 2 adjacent sides opened
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SST_OTHER_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SST_ROOT_STAIR_PART",
		            StoneGateSetPrefix .. "_SST_ROOT_STAIRP_PART",
		            StoneGateSetPrefix .. "_SST_STAIR_PART",   -- stairs with stone floor
		            StoneGateSetPrefix .. "_SST_STAIRP_PART",   -- stairs with wooden floor
         	            StoneGateSetPrefix .. "_SST_STONE_STAIR_RAIL_LEFT_PART", -- 1 side for stairs
		            StoneGateSetPrefix .. "_SST_STONE_STAIR_RAIL_RIGHT_PART",  -- 1 side for stairs
		            StoneGateSetPrefix .. "_WFDECORATION_STAIR_RAIL_R_PART",
		            StoneGateSetPrefix .. "_WFDECORATION_STAIR_RAIL_L_PART",
		            StoneGateSetPrefix .. "_SST_BRIDGE1_PART",   -- simple bridge part with stone floor
		            StoneGateSetPrefix .. "_SST_BRIDGE1P_PART",  -- simple bridge part with wooden floor
		            StoneGateSetPrefix .. "_SST_STONE_FLOOR_PART",  -- floor with stone floor
		            StoneGateSetPrefix .. "_SST_STONE_FLOORP_PART", -- floor with wooden floor
		            StoneGateSetPrefix .. "_SST_HALF_ARCH_SMALL_PART",-- Small half arch bridge part
		            StoneGateSetPrefix .. "_SST_HALF_ARCH_LARGE_PART",-- Large half arch bridge part
		            StoneGateSetPrefix .. "_SST_ROOTHALFWHITE_PART",
		            StoneGateSetPrefix .. "_WFSST_A_PART",
		            StoneGateSetPrefix .. "_WFSST_B_PART",
		            StoneGateSetPrefix .. "_WFSST_C_PART",
		            StoneGateSetPrefix .. "_WFSST_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSST_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSST_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSST_C_PART",
		            StoneGateSetPrefix .. "_ROOT_PILLINGS_PLATFORM_PART",
		            StoneGateSetPrefix .. "_ROOT_PILLINGS_STAIR_PART", --stairs
		            StoneGateSetPrefix .. "_WFDECORATION_PILLINGS_PART",
		            StoneGateSetPrefix .. "_WFDECORATION_PLATFORM_PART",
		            StoneGateSetPrefix .. "_WFDECORATION_RAIL_PART",
		            StoneGateSetPrefix .. "_WFDECORATION_DOUBLE_SUPPORT_PART",
		            StoneGateSetPrefix .. "_WFDECORATION_ANGLE_SUPPORT_PART",
                        }
                },
 		{
			Name = StoneGateSetPrefix .. "_SGATE_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SGATE_ROOT_ARCH_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_UPPER_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_EXT_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOFA45_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOFA30_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOFA60_PART",
		            StoneGateSetPrefix .. "_SGATE_POINTED_ROOF_A_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_ARCHP_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_UPPERP_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_EXTP_PART",
		            StoneGateSetPrefix .. "_WFSGATE_A_PART",
		            StoneGateSetPrefix .. "_WFSGATE_B_PART",
		            StoneGateSetPrefix .. "_WFSGATE_C_PART",
		            StoneGateSetPrefix .. "_WFSGATE_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSGATE_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSGATE_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSGATE_C_PART",
		            StoneGateSetPrefix .. "_SGATE_RAMPART_A_PART",
		            StoneGateSetPrefix .. "_SGATE_RAMPART_CLOSING_L_PART",
		            StoneGateSetPrefix .. "_SGATE_RAMPART_CLOSING_R_PART",
		            StoneGateSetPrefix .. "_HOARDING_SGATE_D_PART", -- on full rampart
		            StoneGateSetPrefix .. "_HOARDING_SGATE_EXTENSION_PART", -- on full rampart
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_RAMPART_C_PART", -- on full rampart, 2 sides, stone floor
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_RAMPART_E_PART", -- on full rampart, 1 side, stone floor
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_RAMPART_CP_PART", -- on full rampart, 2 sides, wooden floor
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_RAMPART_EP_PART", -- on full rampart, 1 side, wooden floor 
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_ROOF_D45_PART", -- on full rampart, 2 opposite sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_ROOF_D30_PART", -- on full rampart, 2 opposite sides opened
		            StoneGateSetPrefix .. "_MACHICOLATION_SGATE_ROOF_D60_PART", -- on full rampart, 2 opposite sides opened
		            StoneGateSetPrefix .. "_SGATE_POINTED_ROOF_MA_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_ARCH_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_UPPER_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_EXT_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_ARCHP_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_UPPERP_PART",
		            StoneGateSetPrefix .. "_SGATE_ROOT_HALF_ROOF_EXTP_PART",
		            StoneGateSetPrefix .. "_HOARDING_SGATE_A_PART", -- over Half-roof
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_A_PART", -- over Half-roof, stone floor
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_AP_PART", -- over Half-roof, wooden floor
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_CLOSING_L_PART",
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_CLOSING_R_PART",
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_WOODEN_ROOF_A_PART", -- over Half-roof
		            StoneGateSetPrefix .. "_SGATE_MACHICOLATION_STONE_ROOF_A_PART"   -- over Half-roof
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_A45_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_A45_ROOT_PART",  -- with stone floor
		            StoneGateSetPrefix .. "_A45_ROOTP_PART", -- with wooden floor
		            StoneGateSetPrefix .. "_A45_ROOF45_PART",
		            StoneGateSetPrefix .. "_A45_ROOF30_PART",
		            StoneGateSetPrefix .. "_A45_ROOF60_PART",
		            StoneGateSetPrefix .. "_A45_POINTED_ROOF_A_PART",
		            StoneGateSetPrefix .. "_A45_RAMPART_A_PART",
		            StoneGateSetPrefix .. "_HOARDING_A45_D_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_A45_RAMPART_E_PART", -- on full rampart, 1 side, stone floor
		            StoneGateSetPrefix .. "_MACHICOLATION_A45_RAMPART_EP_PART", -- on full rampart, 1 side, wooden floor
		            StoneGateSetPrefix .. "_MACHICOLATION_A45_ROOF_E45_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_A45_ROOF_E30_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_A45_ROOF_E60_PART",
		            StoneGateSetPrefix .. "_A45_POINTED_ROOF_MA_PART",
		            StoneGateSetPrefix .. "_WFA45_A_PART",
		            StoneGateSetPrefix .. "_WFA45_B_PART",
		            StoneGateSetPrefix .. "_WFA45_C_PART",
		            StoneGateSetPrefix .. "_WFA45_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFA45_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFA45_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFA45_C_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_OTOWER_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_OTOWER_ROOT_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOTP_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOTHALFWHITE_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOF45_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOF30_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOF60_PART",
		            StoneGateSetPrefix .. "_OTOWER_ROOF_DOME_PART",
		            StoneGateSetPrefix .. "_OTOWER_POINTED_ROOF_PART",
		            StoneGateSetPrefix .. "_OTOWER_RAMPART_PART", -- all sides
		            StoneGateSetPrefix .. "_OTOWER_RAMPART_1SIDE_PART", -- one side
		            StoneGateSetPrefix .. "_OTOWER_RAMPART_1SIDE_OPENED_PART", -- one side open
		            StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
		            StoneGateSetPrefix .. "_OTOWER_HOARDING_EXT_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_OTOWER_RAMPART_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_OTOWER_RAMPARTP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_OTOWER_ROOF_PLATFORM_PART",
		            StoneGateSetPrefix .. "_WFOTOWER_A_PART",
		            StoneGateSetPrefix .. "_WFOTOWER_B_PART",
		            StoneGateSetPrefix .. "_WFOTOWER_C_PART",
		            StoneGateSetPrefix .. "_WFOTOWER_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFOTOWER_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFOTOWER_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFOTOWER_C_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_CIRCULAR_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_CIRCULAR_ROOT_PART",  -- with stone floor
		            StoneGateSetPrefix .. "_CIRCULAR_ROOTP_PART", -- with wooden floor
		            StoneGateSetPrefix .. "_CIRCULAR_ROOTHALFWHITE_PART",  -- basement and half-timbered
		            StoneGateSetPrefix .. "_CIRCULAR_ROOF45_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_ROOF30_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_ROOF60_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_ROOF_DOME_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_POINTED_ROOF_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_RAMPART_PART", -- all sides
		            StoneGateSetPrefix .. "_CIRCULAR_RAMPART_1SIDE_PART", -- one side
		            StoneGateSetPrefix .. "_MACHICOLATION_CIRCULAR_RAMPART_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CIRCULAR_RAMPARTP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_CIRCULAR_ROOF_PLATFORM_PART",
		            StoneGateSetPrefix .. "_CIRCULAR_HOARDING_PART",
		            StoneGateSetPrefix .. "_WFCIRCULAR_A_PART",
		            StoneGateSetPrefix .. "_WFCIRCULAR_B_PART",
		            StoneGateSetPrefix .. "_WFCIRCULAR_C_PART",
		            StoneGateSetPrefix .. "_WFCIRCULAR_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFCIRCULAR_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFCIRCULAR_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFCIRCULAR_C_PART",
                        }
                },
		{
			Name = StoneGateSetPrefix .. "_SCT_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_SCT_ROOT_PART",  -- with stone floor
		            StoneGateSetPrefix .. "_SCT_ROOTP_PART", -- with wooden floor
		            StoneGateSetPrefix .. "_SCT_ROOTHALFWHITE_PART", -- half timbered
		            StoneGateSetPrefix .. "_SCT_ROOF45_PART", -- standard roof
		            StoneGateSetPrefix .. "_SCT_ROOF30_PART", -- standard roof
		            StoneGateSetPrefix .. "_SCT_ROOF60_PART", -- standard roof
		            StoneGateSetPrefix .. "_SCT_ROOF_DOME_PART",
		            StoneGateSetPrefix .. "_SCT_STONE_FLOOR_BASE_PART", -- stone floor base with stone ground
		            StoneGateSetPrefix .. "_SCT_STONE_FLOOR_BASEP_PART", -- stone floor base with wooden ground
		            StoneGateSetPrefix .. "_SCT_STONE_FLOOR_PART", -- stone floor with stone ground
		            StoneGateSetPrefix .. "_SCT_STONE_FLOORP_PART", -- stone floor with wooden ground
		            StoneGateSetPrefix .. "_SCT_POINTED_ROOF_PART",
		            StoneGateSetPrefix .. "_SCT_RAMPART_CLOSED_PART", -- full circle
		            StoneGateSetPrefix .. "_SCT_RAMPART_HALF_PART", -- half circle
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_RAMPART_CLOSED_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_RAMPART_HALF_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_RAMPART_CLOSEDP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_RAMPART_HALFP_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_ROOF45_PART", -- Closed roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_ROOF30_PART", -- Closed roof
		            StoneGateSetPrefix .. "_MACHICOLATION_SCT_ROOF60_PART", -- Closed roof
		            StoneGateSetPrefix .. "_SCT_POINTED_ROOF_MACHICOLATION_PART",
		            StoneGateSetPrefix .. "_WFSCT_A_PART",
		            StoneGateSetPrefix .. "_WFSCT_B_PART",
		            StoneGateSetPrefix .. "_WFSCT_C_PART",
		            StoneGateSetPrefix .. "_WFSCT_D_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSCT_A_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSCT_B_PART",
		            StoneGateSetPrefixWhiteFloor .. "_WFSCT_C_PART",
                        }
                },

		{
			Name = StoneGateSetPrefix .. "_ENTRANCE_PARTSETLIST_NAME",
	                BuildingPartList = {
 		            CommonDoorPrefix .. "_ENTRANCE_DOOR_A_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_DOOR_B_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_C_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_D_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_E_PART",
		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_AMERICAN_DOOR_1_PART",
 		            StoneGateSetPrefix .. "_SST_DOOR_STAIR_PART",   -- stairs foundation with stone floor
		            StoneGateSetPrefix .. "_SST_DOOR_STAIRP_PART",   -- stairs foundation with wooden floor
		            StoneGateSetPrefix .. "_SST_ROOT_DOOR_STAIR_PART",   -- scaleable stairs foundation with stone floor
		            StoneGateSetPrefix .. "_SST_ROOT_DOOR_STAIRP_PART",   -- scaleable stairs foundation with wooden floor
		            StoneGateSetPrefix .. "_ROOT_PILLINGS_DOOR_PART", -- scaleable wooden stairs foundation
                      }
                },

                {
			Name = StoneGateSetPrefix .. "_BRIDGE_PARTSETLIST_NAME",
	                BuildingPartList = {
		            StoneGateSetPrefix .. "_DRAW_BRIDGE_A_CORE_PART",
		            StoneGateSetPrefix .. "_DRAW_BRIDGE_B_CORE_PART",
		            StoneGateSetPrefix .. "_DRAW_BRIDGE_C_CORE_PART",
		            StoneGateSetPrefix .. "_DRAW_BRIDGE_PORTCULLIS_PART"
                        }
                },

		{
			Name = StoneGateSetPrefix .. "_DECORATION_PARTSETLIST_NAME",
	                BuildingPartList = {
                            -- the minor attach point are upside-down related to vanilla in this version, so it is planned for a V8
                            -- "BUILDING_PART_GATE_WALL_BANNER",
		            CommonWindowPrefix .. "_CORNER_ROOT_PART",
		            CommonWindowPrefix .. "_DECORATION_SFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_LFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_PFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_ARROWSLIT_PART",
		            CommonWindowPrefix .. "_DECORATION_BALCONY_PART",
		            StoneGateSetPrefix .. "_DECORATION_DOOR_A_PART",
		            StoneGateSetPrefix .. "_DECORATION_DOOR_B_PART",
		            StoneGateSetPrefix .. "_DECORATION_DOOR_MA_PART",
		            StoneGateSetPrefix .. "_DECORATION_DOOR_MB_PART",
		            CommonWindowPrefix .. "_DECORATION_BUTTRESS_PART",
		            CommonWindowPrefix .. "_DECORATION_BUTTRESS_LARGE_PART",
		            CommonWindowPrefix .. "_DECORATION_BUTTRESS_CORNER_PART",
		            CommonWindowPrefix .. "_DECORATION_CHIMNEY_PART",
		            CommonWindowPrefix .. "_DECORATION_LUCARNE_PART",
		            CommonWindowPrefix .. "_DECORATION_MEDIUM_LUCARNE_PART",
		            CommonWindowPrefix .. "_DECORATION_LARGE_LUCARNE_PART",
		            CommonWindowPrefix .. "_DECORATION_LUCARNE_WHITE_PART",
		            CommonWindowPrefix .. "_DECORATION_MEDIUM_LUCARNE_WHITE_PART",
		            CommonWindowPrefix .. "_DECORATION_LARGE_LUCARNE_WHITE_PART",
		            CommonWindowPrefix .. "_DECORATION_TURRET_PART",
		            CommonWindowPrefix .. "_DECORATION_STONE_ROUND_WINDOW_PART",
		            _CommonFlagPrefix .. "_FLAME_ROOT_PART",
		            CommonWindowPrefix .. "_DECORATION_FINIAL1_PART",
		            CommonWindowPrefix .. "_DECORATION_FINIAL2_PART",
		            CommonWindowPrefix .. "_DECORATION_FINIAL3_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_1_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_2_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_3_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_4_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_8_PART",
		            CommonWindowPrefix .. "_DECORATION_SPLENDOR_2_PART",
		            CommonWindowPrefix .. "_DECORATION_P_STAINED_GLASS_1_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_TALL_1_PART",
		            CommonWindowPrefix .. "_DECORATION_STAINED_GLASS_TALL_2_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_18_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_3_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_9_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_7_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_8_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_LARGE_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_POINTED_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_ROUND_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_AMERICAN_WINDOW_1_PART",
                        }
                },
    }
end

function checkVersion(_mod, _modName, _name, _id, _minimalVersion)
    if (foundation.getModVersion == nil) then
        _mod:logError(_modName .. " Unknown mod version")
        return false
    end
    if not foundation.isModEnabled(_id) then
        _mod:logError(_modName .. " " .. _name .. " disabled")
        return false
    end
    if not foundation.isModLoaded(_id) then
        _mod:logWarning(_modName .. " Up the position of " .. _name .. " in the mod list of your game")
        return false
    end
    local _myVersion = foundation.getModVersion(_id)
    _mod:msgBox(_modName .. " " .. _name .. " Current version : " .. _myVersion)
    if version.cmp(_myVersion, _minimalVersion) < 0 then
        _mod:logWarning(_modName .. " Please, load at least the version " .. _minimalVersion .. " of " .. _name)
        return false
    end
    return true
end

-- Set the sandbox option
function difficultyLevel(_mod, _modName)
    if foundation.isModEnabled("8f186d4a-7b5d-4b8a-b959-43bd254ca95b") then
        _mod:log("Hello World: " .. _modName .. " sandbox mode.")
        return 0
    end
    _mod:log("Hello World: " .. _modName .. " difficulty level low by default")
    return 1
end

--------------------------------------------------------------------------
function computeElevation(_self, _initialPosition, _flagList)
    local _flags = 0
    for i, flag in ipairs(_flagList) do
        _flags = bit.bor(_flags, bit.lshift(1, flag:toNumber()))
    end
    if _flags == 0 then
         _CommonFunctions:logWarning("computeElevation: _flagList empty")
         return _initialPosition[2]
    end 
    local raycastResult = {}

    -- Raycast from the building position + Y = 100
    -- to building position - y = 100
    -- only on objects with a WATER flag
    local FromPosition = { _initialPosition[1], _initialPosition[2]+100, _initialPosition[3] }
    local ToPosition = { _initialPosition[1], _initialPosition[2]-100, _initialPosition[3] }
    
    if not _self:getLevel():rayCast(FromPosition, ToPosition, raycastResult, _flags) then
         _CommonFunctions:logWarning("computeElevation: not any flag found " .. tostring(_flagList))
         return nil
    end
    return raycastResult["Position"][2] 
end


